From caecd1f199eec79d4b79a53bc3431fefb7405f4b Mon Sep 17 00:00:00 2001
From: Junwang Zhao <zhjwpku@gmail.com>
Date: Wed, 26 Apr 2023 09:43:56 +0800
Subject: [PATCH v1] [pg_rewind] use the passing callback instead of global
 function

`local_traverse_files` and `libpq_traverse_files` both have a
callback parameter but instead use the global process_source_file
which is no good for function encapsulation.

Signed-off-by: Junwang Zhao <zhjwpku@gmail.com>
---
 src/bin/pg_rewind/libpq_source.c | 2 +-
 src/bin/pg_rewind/local_source.c | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

diff --git a/src/bin/pg_rewind/libpq_source.c b/src/bin/pg_rewind/libpq_source.c
index 5f486b2a61..0d8e9ee2d1 100644
--- a/src/bin/pg_rewind/libpq_source.c
+++ b/src/bin/pg_rewind/libpq_source.c
@@ -304,7 +304,7 @@ libpq_traverse_files(rewind_source *source, process_file_callback_t callback)
 		else
 			type = FILE_TYPE_REGULAR;
 
-		process_source_file(path, type, filesize, link_target);
+		callback(path, type, filesize, link_target);
 	}
 	PQclear(res);
 }
diff --git a/src/bin/pg_rewind/local_source.c b/src/bin/pg_rewind/local_source.c
index 4e2a1376c6..9bd43cba74 100644
--- a/src/bin/pg_rewind/local_source.c
+++ b/src/bin/pg_rewind/local_source.c
@@ -59,7 +59,7 @@ init_local_source(const char *datadir)
 static void
 local_traverse_files(rewind_source *source, process_file_callback_t callback)
 {
-	traverse_datadir(((local_source *) source)->datadir, &process_source_file);
+	traverse_datadir(((local_source *) source)->datadir, callback);
 }
 
 static char *
-- 
2.33.0

